Properly handle empty DO REPEAT...END REPEAT block. Fixes bug #18407.
authorBen Pfaff <blp@gnu.org>
Fri, 1 Dec 2006 06:45:52 +0000 (06:45 +0000)
committerBen Pfaff <blp@gnu.org>
Fri, 1 Dec 2006 06:45:52 +0000 (06:45 +0000)
Thanks to John Darrington for reporting this bug.

tests/bugs/empty-do-repeat.sh [new file with mode: 0755]

diff --git a/tests/bugs/empty-do-repeat.sh b/tests/bugs/empty-do-repeat.sh
new file mode 100755 (executable)
index 0000000..ad82c23
--- /dev/null
@@ -0,0 +1,73 @@
+#!/bin/sh
+
+# This program tests for a bug that crashed PSPP given an empty DO
+# REPEAT...END REPEAT block.  See bug #18407.
+
+TEMPDIR=/tmp/pspp-tst-$$
+TESTFILE=$TEMPDIR/`basename $0`.sps
+
+# ensure that top_builddir  are absolute
+if [ -z "$top_builddir" ] ; then top_builddir=. ; fi
+if [ -z "$top_srcdir" ] ; then top_srcdir=. ; fi
+top_builddir=`cd $top_builddir; pwd`
+PSPP=$top_builddir/src/ui/terminal/pspp
+
+# ensure that top_srcdir is absolute
+top_srcdir=`cd $top_srcdir; pwd`
+
+STAT_CONFIG_PATH=$top_srcdir/config
+export STAT_CONFIG_PATH
+
+
+cleanup()
+{
+     cd /
+     rm -rf $TEMPDIR
+}
+
+
+fail()
+{
+    echo $activity
+    echo FAILED
+    cleanup;
+    exit 1;
+}
+
+
+no_result()
+{
+    echo $activity
+    echo NO RESULT;
+    cleanup;
+    exit 2;
+}
+
+pass()
+{
+    cleanup;
+    exit 0;
+}
+
+mkdir -p $TEMPDIR
+
+cd $TEMPDIR
+
+activity="create program"
+cat > $TEMPDIR/repeat.stat <<EOF
+DATA LIST NOTABLE /a 1.
+BEGIN DATA.
+0
+END DATA.
+
+DO REPEAT h = a.
+END REPEAT.
+EOF
+if [ $? -ne 0 ] ; then no_result ; fi
+
+# Must not crash.
+activity="run program"
+$SUPERVISOR $PSPP $TEMPDIR/repeat.stat 
+if [ $? -ne 0 ] ; then fail ; fi
+
+pass;